//******************************************************************************
// JspMenu.java     :	 Applet
// Coder            :    Jeremy C. Witt -Wintermute-
// Date Started     :    September 20th 1997
// Last Updated     :    November 28th 1997
// Version          :    1.1
// Copyright        :    All Rights Reserverd
// Desc             :    This applet implements a Brand
//                       New menuing system. This is my
//                       First Original work
//                       (i.e. not recreated ideas)
// Comments         :    Long Live Quake
// NOTE HTTP Struc  :    Menus are delimited in a unique way
//                       the following rules apply
//                       1) Top Level Menus are like Item0-0...Item<N>-0
//                       2) Subs are Delimited by    Item<n>-0...Item<n>-<m>
//                       3) There must be a Subs<n> Var for each Top level menu
//                          item describing the number of subs.. 0 for none(0 Assumed)
//                       4) URL<N>-<M> for Links
//                       5) Message<N>-<M> for Message Texts
//                       6) Target<N>-<M>  for Targets These follow the Item Scheme
// Note on my
// Apparent Usage
// of CRACK         :   Ok OK, I made some very costly design mistakes in this one
//                      that is, I didn't spend the appropriate time with thinking
//                      this problem out. There are several examples of this in this
//                      applet. First, I should have written the DoGrafixUpdate as
//                      a General Procedure with Case Statements to handle the
//                      *descrepencies* in the Animation Parts not the AnimParts
//                      themselves. Secondly, and probably worse, the fact that I
//                      made a very constrictive Parameter Structure for the menu
//                      which doesn't allow Levels greater than two and is Very
//                      Cumbersome to check. If had it to do over again (And I Might)
//                      I would've made a Structure for the incoming MenuData.
//                      one Record be made of the following parts
//                      1) String Item Text (The Item of course)
//                      2) String URL       (The Link could be null)
//                      3) String Target    (The Target Could be null)
//                      4) int MenuIDLevel  (tells which Menu its in [Top Sub1 etc..])
//                      5) int MenuIDPos    (tells which Position it's in[0,1,etc..])
//                      6) boolean SUB      (Whether to ignore URL and goto SubMenu)
//                      7) int LinkIDLevel  (Tells which Level to show after click)
//                      8) int BackIDLevel  (Tells where it came from. to can get back)
//                      9) int XPos         (X Position on Applet)
//                      10)int YPos         (Y Position on Applet)
//                      11)int width        (Width of Text Part)
//                      12)int height       (Height of Text Part)
//
//                      The class would have a vector of these records and routines
//                      that could Fetch Record(MenuIDLevel,MenuIDPos)
//
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;


// Main Class for applet JspMenu
// *****************************************************
public class JspMenu extends Applet implements Runnable
{
	// THREAD SUPPORT:
	// m_Menu is the Thread object for the applet
	Thread	 m_JspMenu = null;

    // Parameter Support
    // Members for applet parameters
    // ***********************************************************************
	int    m_NumItems       = 1;            // Number of Menu Items
	String m_BGColor        = "000000";     // Background Color +
	String m_TFColor        = "909090";     // Fore Text Color +
	String m_THColor        = "FFFFFF";     // Fore Text Color Highlight +
	String m_FlareColor     = "00FF00";     // Flare Color +
	String m_RectColor      = "FFFFFF";     // Color of the Rectangle
	int    m_Spacing        = 20;           // Spacing between entries
	String m_defaultTarget  = "_top";       // Default Target
	String m_Location       = "LEFT";       // Left or Right Applet location
	int    m_AStyle         = 1;            // Applet Style (Not Yet Implemented)
	String m_font           = "Helvetica";  // Font Type
	String m_style          = "PLAIN";      // Font Style (BG Font is Bold)
	int    m_size           = 10;           // Font Base Size
	int    m_fps            = 15;           // Frms/Sec(Update Speed)
	String m_DrawRect       = "NO";         // Draw a Rect around Item?
	String m_ChopFade       = "YES";        // Stop fade last text line?
	float  m_BarThick       = 40;           // Thicknss (or height rather) of fadebar
	int    m_Correction     = 2;            // Correction Factor for Offset of Text (Netscape Error)
	Color[] m_ColorList;                    // This is the Array that holds the Faded Colors

    // parameter names. to change the name of a parameter,
	// you need only make a single change. simply modify
	// the value of the parameter string below.
    // *************************************************
	final String PARAM_font         = "font";
	final String PARAM_style        = "style";
	final String PARAM_size         = "size";
	final String PARAM_fps          = "fps";
	final String PARAM_BGColor      = "bgcolor";
	final String PARAM_TFColor      = "tfcolor";
	final String PARAM_THColor      = "thcolor";
	final String PARAM_FlareColor   = "flarecolor";
	final String PARAM_RectColor    = "rectcolor";
	final String PARAM_NumItems     = "numitems";
	final String PARAM_Spacing      = "spacing";
	final String PARAM_defaultTarget= "deftarget";
	final String PARAM_Location     = "location";
	final String PARAM_AStyle       = "astyle";
	final String PARAM_DrawRect     = "drawrect";
	final String PARAM_ChopFade     = "chopfade";
	final String PARAM_BarThick     = "barthick";
	final String PARAM_Correction   = "correction";


    // Other member Variables
    // ******************************************************************************
    private Vector m_URL      = new Vector(10,10);  // This holds URL Vectors
    private Vector m_Target   = new Vector(10,10);  // This holds Target Vectors
    private Vector m_Message  = new Vector(10,10);  // This holds Message Vectors
    private Vector m_Item     = new Vector(10,10);  // Menu Item Vectors
    private int[]  m_Subs;                          // Dynamic Array Replacement **JW**
    private Font TFfont;                            // Foreground Font
    private FontMetrics ff;                         // Forground FontMetrics
    private Color m_CurrFTColor;                    // The Color used currently for Forgrnd Text
    private Color m_ForeTColor;                     // Color Var for ForeGround Text
    private Color m_HlteTColor;                     // Highlight Color Var for Forg Text
    private Color m_BackgColor;                     // Background Color
    private Color m_FlreColor;                      // Base Color for the Flare
    private Color m_RctColor;                       // color of the Rectangle
    private int   CMouse_X;                         // Mouse location X
    private int   CMouse_Y;                         // Mouse Location Y
    private int   m_Level=-1;                       // Current SubMenu Displayed if not Neg
    private float FadePercent=1;                    // Current Fade Percent (Menu)
    private int   FXPos=0;                          // X Position of the Flare
    private int   FYPos=0;                          // Y Position of the Flare
    private float FadeIncr=(float)0.05;             // Fade Speed for Menu
    private int   TextYOffset;                      // Current Text Y Offset Dist
    private int   MaxYOffset;                       // The Maximum Attained Y Offset

    // This will indicates the most recent thing the mouse went over.
    // In the Form "<n>-<m>" for menu and "BACK" for go Back to Main..
    private String MouseOvered="NO";

    // The next Varialbe controls the correct Animation part
    // 0=no anim. 1=fade menu to black 2=fade black to menu
    // 3(TBI)=Slide Left 4=Slide Right (Replacing with menu)
    // Note 3 and 4 are future enhancements.
    private int   AnimPart;     // This is the Animation Cycle


	// Set up Double Buffer Stuff
	Graphics DBGrafix;
	Image    DBImage;

	// APPLET INFO SUPPORT:
	// The getAppletInfo() method returns a string describing the applet's
	// author, copyright date, or miscellaneous information.
    // *******************************************************************
	public String getAppletInfo()
	{
		return "Name: JspMenu\r\n" +
		       "Author: Jeremy C. Witt (Reverse Engineered)\r\n" +
		       "Created on 9-20-97";
	}

	// PARAMETER SUPPORT
	// The getParameterInfo() method returns an array of strings describing
	// the parameters understood by this applet.
	//
    // Marquee Parameter Information:
    //  { "Name", "Type", "Description" },
    // **********************************************
	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_NumItems, "int", "Umm I'll get to this later" },
		};
		return info;
	}

    // INIT. Most of the Heavy Duty Initialization is contained here
    // **************************************************************
    public void init()
	{
	    int i           = 0;                // Loop Variables
	    int j           = 0;                // Loop Variables
	    Integer tCSubs  = new Integer(0);   // Current Number of SubmenuItems
	    String tURL     = "url";            // Url Concat String
	    String tTar     = "target";         // Target Concat
	    String tMes     = "message";        // Message Concat
	    String tText    = "item";           // Item Concat
	    String tSub     = "sub";            // Subs Concat
	    String tOutr    = "";               // temp Outer
        String tInnr    = "";               // temp Inner
        String tTemp    = "";               // just temp
	    String param;                       // Param
	    Vector tempURL;                     // Temp Vector URL
	    Vector tempItem;                    // " Item
	    Vector tempMessage;                 // " Message
	    Vector tempTarget;                  // " Target


	  	//----GET THE PARAMS JW------------
		// ********************************
		param = getParameter(PARAM_font);
		if (param != null)
			m_font = param;
		param = getParameter(PARAM_style);
		if (param != null)
			m_style = param;
		param = getParameter(PARAM_size);
		if (param != null)
			m_size = Integer.parseInt(param);
		param = getParameter(PARAM_fps);
		if (param != null)
			m_fps = Integer.parseInt(param);
        param = getParameter(PARAM_BGColor);
        if (param != null)
            m_BGColor = param;
        param = getParameter(PARAM_THColor);
        if (param != null)
            m_THColor = param;
        param = getParameter(PARAM_TFColor);
        if (param != null)
            m_TFColor = param;
        param = getParameter(PARAM_FlareColor);
        if (param != null)
            m_FlareColor = param;
        param = getParameter(PARAM_AStyle);
        if (param != null)
            m_AStyle = Integer.parseInt(param);
        param = getParameter(PARAM_Spacing);
        if (param != null)
            m_Spacing = Integer.parseInt(param);
        param = getParameter(PARAM_defaultTarget);
        if (param != null)
            m_defaultTarget = param;
        param = getParameter(PARAM_Location);
        if (param != null)
            m_Location = param;
        param = getParameter(PARAM_RectColor);
        if (param != null)
            m_RectColor = param;
        param = getParameter(PARAM_DrawRect);
        if (param != null)
            m_DrawRect  = param;
        param = getParameter(PARAM_ChopFade);
        if (param != null)
            m_ChopFade = param;
        param = getParameter(PARAM_BarThick);
        if (param != null)
            m_BarThick = Integer.parseInt(param);
        param = getParameter(PARAM_Correction);
        if (param != null)
            m_Correction = Integer.parseInt(param);
        param = getParameter(PARAM_NumItems);
        if (param != null)
        {
            m_NumItems = Integer.parseInt(param);
            m_Subs = new int[m_NumItems];
            while (i < m_NumItems)
            {
                // Get the Number of SubItems
                // For Current [i] Menu Item
                tTemp = tSub + i;
                param = getParameter(tTemp);

                if (param != null)
                {
                    m_Subs[i] = Integer.parseInt(param);
                }
                else
                {
                    m_Subs[i] = 0;
                }
                tempURL=        new Vector(10,10);
                tempMessage=    new Vector(10,10);
                tempTarget=     new Vector(10,10);
                tempItem=       new Vector(10,10);


                // HAHA I did something pretty dumb here.. But I left it
                // cause I'm lazy.. I could have made just one var instead
                // of BOTH tOutr and tInner. :)
                while (j <= m_Subs[i])
                {
                    tOutr = tText + i; // Make item[i] String
                    tInnr = tOutr + "-" + j; // make item[i]-[j]
                    param = getParameter(tInnr);
                    if (param != null)
                        tempItem.addElement(param);
                    else
                        tempItem.addElement("NoString");


                    tOutr = tURL + i; // Make url[i] String
                    tInnr = tOutr + "-" + j; // Make url[i]-[j]
                    param = getParameter(tInnr);
                    if (param != null)
                        tempURL.addElement(param);
                    else
                        tempURL.addElement("S");


                    // Make Target Vector Additions
                    tOutr = tTar + i; // Make target[i] String
                    tInnr = tOutr + "-" + j; // Make target[i]-[j]
                    param = getParameter(tInnr);
                    if (param != null)
                        tempTarget.addElement(param);
                    else
                        tempTarget.addElement(m_defaultTarget);

                    // Make Message Additions
                    tOutr = tMes + i; // Make message[i] String
                    tInnr = tOutr + "-" + j; // Make message[i]-[j] String
                    param = getParameter(tInnr);
                    if (param != null)
                        tempMessage.addElement(param);
                    else
                        tempMessage.addElement("");
                    // Increment Inner loop variable
                    j++;
                }

                // Add the tempVectors to the real Vectors
                m_URL.addElement(tempURL);
                m_Message.addElement(tempMessage);
                m_Target.addElement(tempTarget);
                m_Item.addElement(tempItem);
                j =0 ;
                // Increment outter loop variable
                i++;
            }
        } // End of if NumItems != NULL Whew...



        // Create the Image Buffer(s)
		DBImage = createImage(size().width,size().height);

		// Get the Grafix context of the image and set it to our Double
		// Buffer
		DBGrafix = DBImage.getGraphics();

        // create the fonts here based on the parameters entered
        int nStyle = Font.PLAIN;
        if (m_style.equalsIgnoreCase("BOLD"))
            nStyle = Font.BOLD;
        if (m_style.equalsIgnoreCase("ITALIC"))
            nStyle = Font.ITALIC;

        TFfont = new Font(m_font, nStyle, m_size); // Make Reg Font


        // Calculate Font and Font Sizing Params for use later
        // as well as Initialize Scroller Variables
        ff = getFontMetrics(TFfont);

        // Set up the Colors and Stuff
        m_ForeTColor    = ColorParse(m_TFColor);
        m_HlteTColor    = ColorParse(m_THColor);
        m_BackgColor    = ColorParse(m_BGColor);
        m_FlreColor     = ColorParse(m_FlareColor);
        m_RctColor      = ColorParse(m_RectColor);

        // Now Calculate the Color Array ***JW** Optimization
        m_ColorList = new Color[(int)m_BarThick];
        for (int n=0;n<(int)m_BarThick;n++)
        {
            if (n > 0)
            {
              m_ColorList[n] = MakeColor(m_FlreColor,m_BackgColor,(float)(1-(float)n/m_BarThick));
            }
            else
            {
              m_ColorList[n] = m_FlreColor;
            }
        }
	} // END OF INIT


    // This is the Main Animation Loop Code. It gets executed every sleep
    // cycle If something needs to be done.
    // *******************************************************************
    public void DoGrafixUpdate()
    {
        int     index=0;        // Loop
        String  tString;        // temp String
        Rectangle TextArea;     // Rectangle to indicate Hightlight
        int     tnSubs=0;       // Number of Subs int
        Integer tiSubs;         // Number of Subs Integer
        Polygon tTriang;        // A Polygon for Triangle
        StringTokenizer stBreakEm; //Tokenizer for Parsing String

        // Init Y Offset Variable and Fill to Background Color
        TextYOffset =0;
        DBGrafix.setColor(m_BackgColor);
        DBGrafix.fillRect(0,0,size().width,size().height);

        // The Flare Gets updated regardless of the AnimPart
        DoFlareUpdate();
        MaxYOffset  =0; // Reset MaxYOffset for Next Iteration.
        int tAscent; // **JW**


        // Now Update the Menu Text based upon the
        // current AnimPart
        // 0=Display Current
        // 1=Fade Current to Black
        // 2=Fade Black to New Current
        // 3=Slide Current Left New Replacing it. (Note I probably wont be doing this soon :)
        // 4=Slide Current Right New Replacing it. (This either)
        switch (AnimPart)
        {
            // A better method of implementing this would be to write a
            // generic routine that would handle the repeated stuff
            // and implement the switch for the specific stuff, and not
            // the way it is currently written (The other way around :))
            // This Current AnimPart (0) Actually Keeps the Text Static from Frame to Frame
            // **********************************************************
            case 0: // WARNING HIGHLY UNCOMMENTED! :)
                if (m_Level < 0)
                {
                  DBGrafix.setFont(TFfont);
                  tAscent = ff.getAscent();
                  while (index < m_NumItems)
                  {
                    TextYOffset = m_size+(index*(m_size+5));
                    tString = GetXYEntry(index,0,m_Item);
                    TextArea = new Rectangle(11,TextYOffset-tAscent,ff.stringWidth(tString),m_size);
                    if (TextArea.inside(CMouse_X,CMouse_Y)) // NOTE **JW** Check out the Speed on this!! Ifthen may be faster
                    {
                     DBGrafix.setColor(m_RctColor);
                     if (m_DrawRect.equalsIgnoreCase("Yes"))
                         DBGrafix.draw3DRect(10, TextYOffset-(m_size),
                              ff.stringWidth(tString)+1,m_size+2,false);
                      DBGrafix.setColor(m_HlteTColor);
                      MouseOvered = index + "-0";
                    }
                    else
                      DBGrafix.setColor(m_ForeTColor);
                    DBGrafix.drawString(tString,11,TextYOffset-m_Correction); // Weird Off by One error in Netscape causes offset-1
                    index++;
                  }
                }
                else   // m_Level indicates Submenu
                {
                  DBGrafix.setFont(TFfont);
                  tAscent = ff.getAscent();
                  while (index < m_Subs[m_Level])
                  {
                    TextYOffset = m_size+(index*(m_size+5));
                    tString = GetXYEntry(m_Level,index+1,m_Item);
                    TextArea = new Rectangle(11,TextYOffset-tAscent,ff.stringWidth(tString),m_size);
                    if (TextArea.inside(CMouse_X,CMouse_Y))
                    {
                      DBGrafix.setColor(m_RctColor);
                      if (m_DrawRect.equalsIgnoreCase("Yes"))
                        DBGrafix.draw3DRect(10,TextYOffset-(m_size),ff.stringWidth(tString)+1,m_size+2,false);
                      DBGrafix.setColor(m_HlteTColor);
                      MouseOvered = m_Level + "-" + (index+1);
                    }
                    else
                      DBGrafix.setColor(m_ForeTColor);
                    DBGrafix.drawString(tString,11,TextYOffset-m_Correction);
                    index++;
                  }
                  // Draw Back Arrow and Test to See if it's higlighted
                  TextYOffset = m_size+((index+1)*(m_size+5));
                  tTriang = new Polygon();
                  tTriang.addPoint(11+(m_size>>1),TextYOffset);
                  tTriang.addPoint(11,TextYOffset-(m_size>>1));
                  tTriang.addPoint(11+(m_size>>1),TextYOffset-m_size);
                  tTriang.addPoint(11+(m_size>>1),TextYOffset);
                  if ((CMouse_Y >= TextYOffset-m_size)&&(CMouse_Y<=TextYOffset))
                  {
                      DBGrafix.setColor(m_RctColor);
                      if (m_DrawRect.equalsIgnoreCase("Yes"))
                        DBGrafix.draw3DRect(10,TextYOffset-(m_size+1),
                              ff.stringWidth("Main")+(m_size>>1)+2,m_size+2,false);
                      DBGrafix.setColor(MakeColor(m_HlteTColor,m_BackgColor,FadePercent));
                      MouseOvered="BA";
                  }
                  else
                      DBGrafix.setColor(MakeColor(m_ForeTColor,m_BackgColor,FadePercent));
                  DBGrafix.drawString("Main",12+(m_size>>1),TextYOffset-m_Correction);
                  DBGrafix.fillPolygon(tTriang);
                }
                MaxYOffset = TextYOffset; // Set this Var so ChopFade Works (If set)
            break; // end SubMenu Displayed


            // This Block is the Animation Part Responsible for the Fade to Background
            // This Fades a little each frame then Sets up the init for the Fade Back
            // Up including finding out which menu to display
            // ***********************************************************************
            case 1:
              if (m_Level < 0)
              {
                DBGrafix.setFont(TFfont);
                tAscent=ff.getAscent();
                while (index < m_NumItems)
                {

                  TextYOffset = m_size+(index*(m_size+5));
                  tString = GetXYEntry(index,0,m_Item);
                  TextArea = new Rectangle(11,TextYOffset-tAscent,ff.stringWidth(tString),m_size);
                  if (TextArea.inside(CMouse_X,CMouse_Y))
                  {
                    DBGrafix.setColor(MakeColor(m_RctColor,m_BackgColor,FadePercent)); // **JW** FIX THIS!! Same Prob
                    if (m_DrawRect.equalsIgnoreCase("Yes"))
                      DBGrafix.draw3DRect(10,TextYOffset-(m_size),
                                    ff.stringWidth(tString)+1,m_size+2,false);
                    DBGrafix.setColor(MakeColor(m_HlteTColor,m_BackgColor,FadePercent));
                  }
                  else
                    DBGrafix.setColor(MakeColor(m_ForeTColor,m_BackgColor,FadePercent));
                  DBGrafix.drawString(tString,11,TextYOffset-m_Correction);
                  index++;
                }
                // Here's where the Magic Happens! If you can decipher this,
                // I should commend you on the trip through my convoluted mind!
                FadePercent = FadePercent - FadeIncr;
                if (FadePercent <= 0)
                {
                  FadePercent   =   0;
                  AnimPart      =   2;
                 // Parse the MouseOvered Var and Goto the Correct Menu by setting m_Level
                  if (MouseOvered.equals("BA"))
                     m_Level = -1;
                  else
                  {
                    stBreakEm     = new StringTokenizer(MouseOvered,"-");
                    m_Level = Integer.parseInt(stBreakEm.nextToken());
                   }
                 } // End Magic Block
                } // End IF m_Level <0 Block
                else   // m_Level indicates Submenu
                {
                  DBGrafix.setFont(TFfont);
                  tAscent = ff.getAscent();
                  while (index < m_Subs[m_Level])
                  {
                    TextYOffset = m_size+(index*(m_size+5));
                    tString = GetXYEntry(m_Level,index+1,m_Item);
                    TextArea = new Rectangle(11,TextYOffset-tAscent,ff.stringWidth(tString),m_size);
                    if (TextArea.inside(CMouse_X,CMouse_Y))
                    {
                      DBGrafix.setColor(MakeColor(m_RctColor,m_BackgColor,FadePercent));
                      if (m_DrawRect.equalsIgnoreCase("Yes"))
                          DBGrafix.draw3DRect(10,TextYOffset-(m_size),
                                     ff.stringWidth(tString)+1,m_size+2,false);
                      DBGrafix.setColor(MakeColor(m_HlteTColor,m_BackgColor,FadePercent));
                    }
                    else
                      DBGrafix.setColor(MakeColor(m_ForeTColor,m_BackgColor,FadePercent));
                    DBGrafix.drawString(tString,11,TextYOffset-m_Correction);
                    index++;
                }
                // Draw Back Arrow and Test to See if it's higlighted
                TextYOffset = m_size+((index+1)*(m_size+5));
                tTriang = new Polygon();
                tTriang.addPoint(11+(m_size>>1),TextYOffset);
                tTriang.addPoint(11,TextYOffset-(m_size>>1));
                tTriang.addPoint(11+(m_size>>1),TextYOffset-m_size);
                tTriang.addPoint(11+(m_size>>1),TextYOffset);
                if ((CMouse_Y >= TextYOffset-m_size)&&(CMouse_Y<=TextYOffset))
                {
                  DBGrafix.setColor(MakeColor(m_RctColor,m_BackgColor,FadePercent));
                  if (m_DrawRect.equalsIgnoreCase("Yes"))
                    DBGrafix.draw3DRect(10,TextYOffset-(m_size+1),ff.stringWidth("Main")+(m_size>>1)+2,
                                m_size+2,false);
                  DBGrafix.setColor(MakeColor(m_HlteTColor,m_BackgColor,FadePercent));
                  MouseOvered="BA";
                }
                else
                  DBGrafix.setColor(MakeColor(m_ForeTColor,m_BackgColor,FadePercent));
                DBGrafix.drawString("Main",12+(m_size>>1),TextYOffset-m_Correction);
                DBGrafix.fillPolygon(tTriang);

                // This is the Key to leaving this Animation Part!
                // When the Fade goes to Backg it Parses the MouseOvered Var and
                // sets m_Level to that Menu... then goes to AnimPart 2
                // Which Fades from Black Up.
                FadePercent = FadePercent - FadeIncr;
                if (FadePercent <= 0)
                {
                  FadePercent = 0;
                  AnimPart =2;
                  if (MouseOvered.equals("BA"))
                    m_Level = -1;
                  else
                  {
                    stBreakEm     = new StringTokenizer(MouseOvered,"-");
                    m_Level = Integer.parseInt(stBreakEm.nextToken());
                  }
                }
              } // end SubMenu Displayed
              MaxYOffset = TextYOffset;
            break;

            // This is the Fade from Black to New Menu Animation Part
            // it is called automatically from the AnimPart1 Block
            // *****************************************************
            case 2:
              if (m_Level < 0)
              {
                DBGrafix.setFont(TFfont);
                tAscent = ff.getAscent();
                while (index < m_NumItems)
                {
                  TextYOffset = m_size+(index*(m_size+5));
                  tString = GetXYEntry(index,0,m_Item);
                  TextArea = new Rectangle(11,TextYOffset-tAscent,ff.stringWidth(tString),m_size);
                  if (TextArea.inside(CMouse_X,CMouse_Y))
                  {
                    DBGrafix.setColor(MakeColor(m_RctColor,m_BackgColor,FadePercent));
                    if (m_DrawRect.equalsIgnoreCase("Yes"))
                      DBGrafix.draw3DRect(10,TextYOffset-(m_size),ff.stringWidth(tString)+1,
                                          m_size+2,false);
                    DBGrafix.setColor(MakeColor(m_HlteTColor,m_BackgColor,FadePercent));
                  }
                  else
                    DBGrafix.setColor(MakeColor(m_ForeTColor,m_BackgColor,FadePercent));
                  DBGrafix.drawString(tString,11,TextYOffset-m_Correction);
                  index++;
                }
                FadePercent = FadePercent + FadeIncr;
                if (FadePercent >=1)
                  AnimPart    =0;
              }
              else   // m_Level indicates Submenu
              {
                DBGrafix.setFont(TFfont);
                tAscent = ff.getAscent();
                while (index < m_Subs[m_Level])
                {

                  TextYOffset = m_size+(index*(m_size+5));
                  tString = GetXYEntry(m_Level,index+1,m_Item);
                  TextArea = new Rectangle(11,TextYOffset-tAscent,ff.stringWidth(tString),m_size);
                  if (TextArea.inside(CMouse_X,CMouse_Y))
                  {
                    DBGrafix.setColor(MakeColor(m_RctColor,m_BackgColor,FadePercent));
                    if (m_DrawRect.equalsIgnoreCase("Yes"))
                      DBGrafix.draw3DRect(10,TextYOffset-(m_size),
                                                ff.stringWidth(tString)+1,m_size+2,false);
                    DBGrafix.setColor(MakeColor(m_HlteTColor,m_BackgColor,FadePercent));
                  }
                  else
                    DBGrafix.setColor(MakeColor(m_ForeTColor,m_BackgColor,FadePercent));
                  DBGrafix.drawString(tString,11,TextYOffset-m_Correction);
                  index++;
                }
                // Draw Back Arrow and Test to See if it's higlighted
                TextYOffset = m_size+((index+1)*(m_size+5));
                tTriang = new Polygon();
                tTriang.addPoint(11+(m_size>>1),TextYOffset);
                tTriang.addPoint(11,TextYOffset-(m_size>>1));
                tTriang.addPoint(11+(m_size>>1),TextYOffset-m_size);
                tTriang.addPoint(11+(m_size>>1),TextYOffset);
                if ((CMouse_Y >= TextYOffset-m_size)&&(CMouse_Y<=TextYOffset))
                {
                  DBGrafix.setColor(MakeColor(m_RctColor,m_BackgColor,FadePercent));
                  DBGrafix.draw3DRect(10,TextYOffset-(m_size+1),ff.stringWidth("Main")+(m_size>>1)+2,m_size+2,false);
                  DBGrafix.setColor(MakeColor(m_HlteTColor,m_BackgColor,FadePercent));
                  MouseOvered="BA";
                }
                else
                  DBGrafix.setColor(MakeColor(m_ForeTColor,m_BackgColor,FadePercent));
                DBGrafix.drawString("Main",12+(m_size>>1),TextYOffset-m_Correction);
                DBGrafix.fillPolygon(tTriang);

                // Do the Fade and goto AnimPart 0 (Static Mode) if Fade Done
                FadePercent = FadePercent + FadeIncr;
                if (FadePercent >= 1)
                  AnimPart =0;
              } // end SubMenu Displayed
              MaxYOffset=TextYOffset;
            break;
        } // End Switch
    } // End DoGrafixUPdate
    // ***************************WOOP DAT WAS CRAP*************************************


    // This Procedure serves the purpose of Updating the Fading Bar on the left
    // every frame. Basically the routine is pretty simple. It just paints Lines
    // of More and More Faded versions of the color then updates the position
    // of these lines every frame. A neat extension of this procedure would be the addition
    // of different shapes (i.e. Circle,Arrow,etc..)
    // *********************************************************************************
    public void DoFlareUpdate()
    {
        int   index=0;                  // Loop
        float FlarePrct=1;              // Percent Fade
        Color TempColor;                // Temp Color to Hold Created Fade Color
        int  BarThick=(int)m_BarThick;      // Bar Thickness (JW MAKE PARAM) **JW** Opt Float->int
        while (index < BarThick)
        {
          DBGrafix.setColor(m_ColorList[index]);
          DBGrafix.drawLine(FXPos,FYPos-index,FXPos+10,FYPos-index);
          if (FYPos > size().height+BarThick)
            FYPos = 0;
          if (m_ChopFade.equalsIgnoreCase("YES"))
          {
            DBGrafix.setColor(m_BackgColor);
            DBGrafix.fillRect(0,MaxYOffset,size().width,MaxYOffset+BarThick);
            if (FYPos >= MaxYOffset+BarThick)
              FYPos =0;
          }
          index++;
      }
        FYPos+=2;
    } // End of DoFlareUpdate()


	// Marquee Paint Handler Calls Animation Routine
	// every update.. which happens every sleep cycle
	//***********************************************
	public void paint(Graphics g)
	{
	    DoGrafixUpdate();
		g.drawImage(DBImage,0,0,this);
	}

	// This Routine Takes an [x][y] val and gets the goods stored
	// at that location
	// ***************************************************
	public String GetXYEntry(int x,int y,Vector theVect)
	{
	    String tString;
	    Vector tVector = new Vector(10,10);
	    tVector = (Vector)theVect.elementAt(x);
	    tString = (String)tVector.elementAt(y);
	    return tString;
	}


    // This routine merely takes a string in the form
    // "RRGGBB" where RR is hex Byte (i.e. "A8")
    // and returns the associted Integer Parts into
    // Color Variables
    // ************************************************
	public Color ColorParse(String ColorStr)
	{
	    int Red_Part,Green_Part,Blue_Part;
	    String Temp		= ColorStr.substring(0,2);
		Red_Part		= Integer.parseInt(Temp,16);
		Temp			= ColorStr.substring(2,4);
		Green_Part		= Integer.parseInt(Temp,16);
		Temp			= ColorStr.substring(4);
		Blue_Part		= Integer.parseInt(Temp,16);
		Color newColor  = new Color(Red_Part,Green_Part,Blue_Part);
		return newColor;
	}

	// This Routine Makes a Color that is PercentComp Percent of Color A
	// and the Rest of color b. In other words, Color A is Dominant for
	// Percents higher than 0.50 It will be used in fade routine
	// ***************************************************************
	public Color MakeColor(Color a, Color b, float percentComp)
	{
	    int   ared=0,agreen=0,ablue=0;  // A Color Component Vars
	    int   bred=0,bgreen=0,bblue=0;  // B Color Component Vars
	    float cred=0,cgreen=0,cblue=0;  // C Color Component Vars
	    Color cColor;                   // C Color Var
	    ared           = a.getRed();
	    agreen         = a.getGreen();
	    ablue          = a.getBlue();
	    bred           = b.getRed();
	    bgreen         = b.getGreen();
	    bblue          = b.getBlue();
	    cred           = ((ared*percentComp)+(bred*(1-percentComp)))/(float)255;
	    cgreen         = ((agreen*percentComp)+(bgreen*(1-percentComp)))/(float)255;
	    cblue          = ((ablue*percentComp)+(bblue*(1-percentComp)))/(float)255;
	    cColor         = new Color(cred,cgreen,cblue);
	    return cColor;
	}

    // This is called when you enter the page.
    // It makes it all happen
    // ****************************************
    public void start()
	{
		if (m_JspMenu == null)
		{
			m_JspMenu = new Thread(this);
			m_JspMenu.start();
		}
	}

    // STOP! This is called when you leave the page.
    // *********************************************
	public void stop()
	{
		if (m_JspMenu != null)
		{
			m_JspMenu.stop();
			m_JspMenu = null;
		}
	}


	// Mouse Event Handler
	// Some Specialized Button Down code is contained
	// here, but for the most part, it just records the
	// location of the mouse for use by the other routines.
	// ***********************************************
	 public boolean handleEvent(Event TheEvent)
    {
        StringTokenizer stTemp;             // Tokenizer for Parsing
        String          sURL;               // Temp URL name String
        String          sTarget;            // Temp Target name String
        int             tLevel,tPos,Dummy;  //Matrix Position in Vector of Object
        URL             uTempURL;           // a URl Var that contains the URL info
        switch (TheEvent.id)
        {
            // We need to peek at the Value to see if its supposed to goto a Web Page or not.
            case Event.MOUSE_DOWN:

                if (MouseOvered.equals("NO"))
                {
                    Dummy=1; // Do nothing... yet I may use this later
                    //System.out.println("NO");
                }
                else if (MouseOvered.equals("BA"))
                    AnimPart = 1;
                     //System.out.println("BA");} // Kick off the Animation! Go BACK TO MAIN!
                else // Parse and goto Web Page If there is one. else initialize animation
                {
                    // Gotta do some simple parsing on the MouseOvered String
                    stTemp = new StringTokenizer(MouseOvered,"-");
                    tLevel = Integer.parseInt(stTemp.nextToken());
                    tPos   = Integer.parseInt(stTemp.nextToken());
                    sURL   = GetXYEntry(tLevel,tPos,m_URL);
                    sTarget= GetXYEntry(tLevel,tPos,m_Target);
                    //System.out.println("SURL="+sURL);
                    //System.out.println("x="+tLevel+" y="+tPos);
                    if (sURL.equals("S"))
                        AnimPart = 1; // Kick off Animation (Will start next DoGrafixUpdate Cycle)
                    else
                    {
                        // Goto Web Page
                        // *************
                        try // Standard  Throw Catch Stuff... to Setup URL Var
                        {
                            uTempURL = new URL(sURL);
                            this.getAppletContext().showDocument(uTempURL,sTarget);
                        }
                        catch (MalformedURLException ex)
                        { System.out.println("ARGGGGGGGG.....URL Bad:"+ex.toString());}
                    }
                }
            break;
            case Event.MOUSE_UP:
            break;
            case Event.MOUSE_ENTER:
                CMouse_X = TheEvent.x;     // Set the Current Mouse Location
                CMouse_Y = TheEvent.y;
            break;
            case Event.MOUSE_EXIT:
                CMouse_X = -500;
                CMouse_Y = -500;
                MouseOvered="NO";
            break;
            case Event.MOUSE_MOVE:
                CMouse_X = TheEvent.x;     // Set the Current Mouse Location
                CMouse_Y = TheEvent.y;
            default:
        }
        return false;
    } // End of Mouse Event Handler...


	// THREAD SUPPORT
	// **************************************************
	public void run()
	{
		while (true)
		{
            // calculate the sleep time based on the frames
            // per second. sleep time is in units of
            // milliseconds.
            int nSleepValue = 1000 / m_fps;
			try
			{
				repaint();
                Thread.sleep(nSleepValue);
			}
			catch (InterruptedException e)
			{
				stop();
			}
		}
	}

    // Override invokes paint so double buffer works.
    // **********************************************
	public void update (Graphics g)
	{
		paint(g);
	}


    // Destroy Routine.. Destructor Code.
    // *********************************************************************
	public void destroy()
	{
	}

	// JspMenu Class Constructor
    // **************************
	public JspMenu()
	{
	}

	// JspMenu Class Destructor
    // ************************
	public void finalize()
	{
	}


} // END OF CLASS JspMenu
// ***********************************************************************

